Index: uspace/lib/posix/source/stdio.c
===================================================================
--- uspace/lib/posix/source/stdio.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/stdio.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -53,5 +53,4 @@
 #include "libc/malloc.h"
 #include "libc/adt/list.h"
-#include "libc/sys/stat.h"
 
 /** Clears the stream's error and end-of-file indicators.
@@ -344,7 +343,8 @@
 static int _dprintf_str_write(const char *str, size_t size, void *fd)
 {
-	ssize_t wr = write(*(int *) fd, str, size);
+	const int fildes = *(int *) fd;
+	ssize_t wr = vfs_write(fildes, &posix_pos[fildes], str, size);
 	if (wr < 0)
-		return errno;
+		return wr;
 	return str_nlength(str, wr);
 }
@@ -371,7 +371,7 @@
 		}
 		
-		if (write(*(int *) fd, buf, sz) != (ssize_t) sz) {
+		const int fildes = *(int *) fd;
+		if (vfs_write(fildes, &posix_pos[fildes], buf, sz) < 0)
 			break;
-		}
 		
 		chars++;
@@ -575,5 +575,8 @@
 int posix_remove(const char *path)
 {
-	return negerrno(remove, path);
+	if (rcerrno(vfs_unlink_path, path) != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -587,5 +590,9 @@
 int posix_rename(const char *old, const char *new)
 {
-	return negerrno(rename, old, new);
+	int rc = rcerrno(vfs_rename_path, old, new);
+	if (rc != EOK)
+		return -1;
+	else
+		return 0;
 }
 
Index: uspace/lib/posix/source/stdlib.c
===================================================================
--- uspace/lib/posix/source/stdlib.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/stdlib.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -431,5 +431,5 @@
 		}
 		
-		fd = open(tmpl, O_RDWR | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR);
+		fd = posix_open(tmpl, O_RDWR | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR);
 		
 		if (fd == -1) {
Index: uspace/lib/posix/source/sys/stat.c
===================================================================
--- uspace/lib/posix/source/sys/stat.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/sys/stat.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -39,5 +39,5 @@
 #include "../internal/common.h"
 #include "posix/sys/stat.h"
-#include "libc/sys/stat.h"
+#include "libc/vfs/vfs.h"
 
 #include "posix/errno.h"
@@ -49,6 +49,8 @@
  * @param dest POSIX stat struct.
  * @param src HelenOS stat struct.
+ *
+ * @return 0 on success, -1 on error.
  */
-static void stat_to_posix(struct posix_stat *dest, struct stat *src)
+static int stat_to_posix(struct posix_stat *dest, struct stat *src)
 {
 	memset(dest, 0, sizeof(struct posix_stat));
@@ -68,4 +70,11 @@
 	dest->st_nlink = src->lnkcnt;
 	dest->st_size = src->size;
+
+	if (src->size > INT64_MAX) {
+		errno = ERANGE;
+		return -1;
+	}
+
+	return 0;
 }
 
@@ -80,9 +89,8 @@
 {
 	struct stat hst;
-	int rc = negerrno(fstat, fd, &hst);
+	int rc = rcerrno(vfs_stat, fd, &hst);
 	if (rc < 0)
-		return rc;
-	stat_to_posix(st, &hst);
-	return 0;
+		return -1;
+	return stat_to_posix(st, &hst);
 }
 
@@ -110,9 +118,8 @@
 {
 	struct stat hst;
-	int rc = negerrno(stat, path, &hst);
+	int rc = rcerrno(vfs_stat_path, path, &hst);
 	if (rc < 0)
-		return rc;
-	stat_to_posix(st, &hst);
-	return 0;
+		return -1;
+	return stat_to_posix(st, &hst);
 }
 
@@ -124,5 +131,5 @@
  * @return Zero on success, -1 otherwise.
  */
-int posix_chmod(const char *path, mode_t mode)
+int posix_chmod(const char *path, posix_mode_t mode)
 {
 	/* HelenOS doesn't support permissions, return success. */
@@ -137,5 +144,5 @@
  * @return Previous file mode creation mask.
  */
-mode_t posix_umask(mode_t mask)
+posix_mode_t posix_umask(posix_mode_t mask)
 {
 	/* HelenOS doesn't support permissions, return empty mask. */
@@ -143,4 +150,20 @@
 }
 
+/**
+ * Create a directory.
+ * 
+ * @param path Path to the new directory.
+ * @param mode Permission bits to be set.
+ * @return Zero on success, -1 otherwise.
+ */
+int posix_mkdir(const char *path, posix_mode_t mode)
+{
+	int rc = rcerrno(vfs_link_path, path, KIND_DIRECTORY, NULL);
+	if (rc != EOK)
+		return -1;
+	else
+		return 0;
+}
+
 /** @}
  */
Index: uspace/lib/posix/source/unistd.c
===================================================================
--- uspace/lib/posix/source/unistd.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/lib/posix/source/unistd.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -47,4 +47,7 @@
 #include "libc/stats.h"
 #include "libc/malloc.h"
+#include "libc/vfs/vfs.h"
+
+aoff64_t posix_pos[MAX_OPEN_FILES];
 
 /* Array of environment variable strings (NAME=VALUE). */
@@ -105,12 +108,8 @@
 char *posix_getcwd(char *buf, size_t size)
 {
-	char *p = getcwd(buf, size);
-
-	if (p == NULL) {
-		errno = -errno;
+	int rc = rcerrno(vfs_cwd_get, buf, size);
+	if (rc != EOK) 
 		return NULL;
-	}
-
-	return p;
+	return buf;
 }
 
@@ -122,5 +121,8 @@
 int posix_chdir(const char *path)
 {
-	return negerrno(chdir, path);
+	int rc = rcerrno(vfs_cwd_set, path);
+	if (rc != EOK)
+		return -1;
+	return 0;
 }
 
@@ -175,5 +177,10 @@
 int posix_close(int fildes)
 {
-	return negerrno(close, fildes);
+	posix_pos[fildes] = 0;
+	int rc = rcerrno(vfs_put, fildes);
+	if (rc != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -188,5 +195,8 @@
 ssize_t posix_read(int fildes, void *buf, size_t nbyte)
 {
-	return negerrno(read, fildes, buf, nbyte);
+	ssize_t size = rcerrno(vfs_read, fildes, &posix_pos[fildes], buf, nbyte);
+	if (size < 0)
+		return -1;
+	return size;
 }
 
@@ -201,5 +211,8 @@
 ssize_t posix_write(int fildes, const void *buf, size_t nbyte)
 {
-	return negerrno(write, fildes, buf, nbyte);
+	ssize_t size = rcerrno(vfs_write, fildes, &posix_pos[fildes], buf, nbyte);
+	if (size < 0)
+		return -1;
+	return size;
 }
 
@@ -215,5 +228,27 @@
 posix_off_t posix_lseek(int fildes, posix_off_t offset, int whence)
 {
-	return negerrno(lseek, fildes, offset, whence);
+	struct stat st;
+	int rc;
+
+	switch (whence) {
+	case SEEK_SET:
+		posix_pos[fildes] = offset;
+		break;
+	case SEEK_CUR:
+		posix_pos[fildes] += offset;
+		break;
+	case SEEK_END:
+		rc = rcerrno(vfs_stat, fildes, &st);
+		if (rc != EOK)
+			return -1;
+		posix_pos[fildes] = st.size + offset;
+		break;
+	}
+	if (posix_pos[fildes] > INT64_MAX) {
+		/* The native width is too large for the POSIX interface. */
+		errno = ERANGE;
+		return -1;
+	}
+	return posix_pos[fildes];
 }
 
@@ -226,5 +261,8 @@
 int posix_fsync(int fildes)
 {
-	return negerrno(fsync, fildes);
+	if (rcerrno(vfs_sync, fildes) != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -238,5 +276,8 @@
 int posix_ftruncate(int fildes, posix_off_t length)
 {
-	return negerrno(ftruncate, fildes, (aoff64_t) length);
+	if (rcerrno(vfs_resize, fildes, (aoff64_t) length) != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -249,5 +290,8 @@
 int posix_rmdir(const char *path)
 {
-	return negerrno(rmdir, path);
+	if (rcerrno(vfs_unlink_path, path) != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -260,5 +304,8 @@
 int posix_unlink(const char *path)
 {
-	return negerrno(unlink, path);
+	if (rcerrno(vfs_unlink_path, path) != EOK)
+		return -1;
+	else
+		return 0;
 }
 
@@ -284,5 +331,5 @@
 int posix_dup2(int fildes, int fildes2)
 {
-	return negerrno(dup2, fildes, fildes2);
+	return negerrno(vfs_clone, fildes, fildes2, false);
 }
 
@@ -302,10 +349,8 @@
 		 * Check file existence by attempting to open it.
 		 */
-		int fd = negerrno(open, path, O_RDONLY);
-		if (fd < 0) {
-			/* errno was set by open() */
+		int fd = posix_open(path, O_RDONLY);
+		if (fd < 0)
 			return -1;
-		}
-		close(fd);
+		posix_close(fd);
 		return 0;
 	} else {
Index: uspace/srv/devman/driver.c
===================================================================
--- uspace/srv/devman/driver.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/devman/driver.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -33,7 +33,6 @@
 #include <dirent.h>
 #include <errno.h>
-#include <fcntl.h>
-#include <sys/stat.h>
 #include <io/log.h>
+#include <vfs/vfs.h>
 #include <loc.h>
 #include <str_error.h>
@@ -142,5 +141,5 @@
 	/* Check whether the driver's binary exists. */
 	struct stat s;
-	if (stat(drv->binary_path, &s) != 0) {
+	if (vfs_stat_path(drv->binary_path, &s) != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Driver not found at path `%s'.",
 		    drv->binary_path);
Index: uspace/srv/devman/match.c
===================================================================
--- uspace/srv/devman/match.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/devman/match.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -32,10 +32,9 @@
 
 #include <errno.h>
-#include <fcntl.h>
 #include <io/log.h>
 #include <str.h>
 #include <str_error.h>
 #include <sys/types.h>
-#include <sys/stat.h>
+#include <vfs/vfs.h>
 
 #include "devman.h"
@@ -201,6 +200,7 @@
 	int fd;
 	size_t len = 0;
-	
-	fd = open(conf_path, O_RDONLY);
+	struct stat st;
+	
+	fd = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ);
 	if (fd < 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to open `%s' for reading: %s.",
@@ -210,6 +210,10 @@
 	opened = true;
 	
-	len = lseek(fd, 0, SEEK_END);
-	lseek(fd, 0, SEEK_SET);
+	if (vfs_stat(fd, &st) != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to fstat %d: %s.", fd,
+		    str_error(errno));
+		goto cleanup;
+	}
+	len = st.size;
 	if (len == 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Configuration file '%s' is empty.",
@@ -225,5 +229,5 @@
 	}
 	
-	ssize_t read_bytes = read(fd, buf, len);
+	ssize_t read_bytes = vfs_read(fd, (aoff64_t []) {0}, buf, len);
 	if (read_bytes <= 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s' (%d).", conf_path,
@@ -239,5 +243,5 @@
 	
 	if (opened)
-		close(fd);
+		vfs_put(fd);
 	
 	return suc;
Index: uspace/srv/fs/fat/fat.h
===================================================================
--- uspace/srv/fs/fat/fat.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/fs/fat/fat.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,4 +41,5 @@
 #include <sys/types.h>
 #include <stdbool.h>
+#include <macros.h>
 #include "../../vfs/vfs.h"
 
@@ -46,6 +47,4 @@
 #define dprintf(...)	printf(__VA_ARGS__)
 #endif
-
-#define min(a, b)	((a) < (b) ? (a) : (b))
 
 /*
Index: uspace/srv/fs/locfs/locfs_ops.c
===================================================================
--- uspace/srv/fs/locfs/locfs_ops.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/fs/locfs/locfs_ops.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,5 +45,4 @@
 #include <adt/hash_table.h>
 #include <ipc/loc.h>
-#include <sys/stat.h>
 #include <assert.h>
 #include "locfs.h"
Index: uspace/srv/fs/mfs/mfs.h
===================================================================
--- uspace/srv/fs/mfs/mfs.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/fs/mfs/mfs.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,4 +45,5 @@
 #include <assert.h>
 #include <stdbool.h>
+#include <macros.h>
 #include "../../vfs/vfs.h"
 
@@ -50,6 +51,4 @@
 
 /* #define DEBUG_MODE */
-
-#define min(a, b)	((a) < (b) ? (a) : (b))
 
 #ifdef DEBUG_MODE
Index: uspace/srv/fs/tmpfs/tmpfs_ops.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -54,7 +54,4 @@
 #include <libfs.h>
 
-#define min(a, b)		((a) < (b) ? (a) : (b))
-#define max(a, b)		((a) > (b) ? (a) : (b))
-
 /** All root nodes have index 0. */
 #define TMPFS_SOME_ROOT		0
Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -39,5 +39,4 @@
 #include <stdbool.h>
 #include <errno.h>
-#include <fcntl.h>
 #include <io/console.h>
 #include <io/keycode.h>
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/hid/input/port/adb.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -38,5 +38,4 @@
 #include <async.h>
 #include <vfs/vfs.h>
-#include <fcntl.h>
 #include <errno.h>
 #include <loc.h>
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -37,5 +37,4 @@
 
 #include <stdio.h>
-#include <fcntl.h>
 #include <vfs/vfs_sess.h>
 #include <malloc.h>
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/loader/main.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -48,5 +48,4 @@
 #include <unistd.h>
 #include <stdbool.h>
-#include <fcntl.h>
 #include <sys/types.h>
 #include <ipc/services.h>
@@ -62,9 +61,11 @@
 #include <elf/elf_load.h>
 #include <vfs/vfs.h>
+#include <vfs/inbox.h>
 
 #define DPRINTF(...)
 
-/** Pathname of the file that will be loaded */
-static char *pathname = NULL;
+/** File that will be loaded */
+static char *progname = NULL;
+static int program_fd = -1;
 
 /** The Program control block */
@@ -81,6 +82,7 @@
 static char *arg_buf = NULL;
 
-/** Number of preset files */
-static unsigned int filc = 0;
+/** Inbox entries. */
+static struct pcb_inbox_entry inbox[INBOX_MAX_ENTRIES];
+static int inbox_entries = 0;
 
 static elf_info_t prog_info;
@@ -130,22 +132,34 @@
 }
 
-/** Receive a call setting pathname of the program to execute.
- *
- * @param rid
- * @param request
- */
-static void ldr_set_pathname(ipc_callid_t rid, ipc_call_t *request)
-{
-	char *buf;
-	int rc = async_data_write_accept((void **) &buf, true, 0, 0, 0, NULL);
-	
-	if (rc == EOK) {
-		if (pathname != NULL)
-			free(pathname);
-		
-		pathname = buf;
-	}
-	
-	async_answer_0(rid, rc);
+/** Receive a call setting the program to execute.
+ *
+ * @param rid
+ * @param request
+ */
+static void ldr_set_program(ipc_callid_t rid, ipc_call_t *request)
+{
+	ipc_callid_t writeid;
+	size_t namesize;
+	if (!async_data_write_receive(&writeid, &namesize)) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+
+	char* name = malloc(namesize);
+	int rc = async_data_write_finalize(writeid, name, namesize);
+	if (rc != EOK) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+
+	int file = vfs_receive_handle(true);
+	if (file < 0) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+	
+	progname = name;
+	program_fd = file;
+	async_answer_0(rid, EOK);
 }
 
@@ -215,30 +229,46 @@
 }
 
-/** Receive a call setting preset files of the program to execute.
- *
- * @param rid
- * @param request
- */
-static void ldr_set_files(ipc_callid_t rid, ipc_call_t *request)
-{
-	size_t count = IPC_GET_ARG1(*request);
-
-	async_exch_t *vfs_exch = vfs_exchange_begin();
-
-	for (filc = 0; filc < count; filc++) {
-		ipc_callid_t callid;
-		int fd;
-
-		if (!async_state_change_receive(&callid, NULL, NULL, NULL)) {
-			async_answer_0(callid, EINVAL);
-			break;
-		}
-		async_state_change_finalize(callid, vfs_exch);
-		fd = vfs_fd_wait();
-		assert(fd == (int) filc);
-	}
-
-	vfs_exchange_end(vfs_exch);
-
+/** Receive a call setting inbox files of the program to execute.
+ *
+ * @param rid
+ * @param request
+ */
+static void ldr_add_inbox(ipc_callid_t rid, ipc_call_t *request)
+{
+	if (inbox_entries == INBOX_MAX_ENTRIES) {
+		async_answer_0(rid, ERANGE);
+		return;
+	}
+
+	ipc_callid_t writeid;
+	size_t namesize;
+	if (!async_data_write_receive(&writeid, &namesize)) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+
+	char* name = malloc(namesize);
+	int rc = async_data_write_finalize(writeid, name, namesize);
+	if (rc != EOK) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+
+	int file = vfs_receive_handle(true);
+	if (file < 0) {
+		async_answer_0(rid, EINVAL);
+		return;
+	}
+
+	/*
+	 * We need to set the root early for dynamically linked binaries so
+	 * that the loader can use it too.
+	 */
+	if (str_cmp(name, "root") == 0)
+		vfs_root_set(file);
+
+	inbox[inbox_entries].name = name;
+	inbox[inbox_entries].file = file;
+	inbox_entries++;
 	async_answer_0(rid, EOK);
 }
@@ -252,9 +282,7 @@
 static int ldr_load(ipc_callid_t rid, ipc_call_t *request)
 {
-	int rc;
-	
-	rc = elf_load(pathname, &prog_info);
+	int rc = elf_load(program_fd, &prog_info);
 	if (rc != EE_OK) {
-		DPRINTF("Failed to load executable '%s'.\n", pathname);
+		DPRINTF("Failed to load executable for '%s'.\n", progname);
 		async_answer_0(rid, EINVAL);
 		return 1;
@@ -268,5 +296,6 @@
 	pcb.argv = argv;
 	
-	pcb.filc = filc;
+	pcb.inbox = inbox;
+	pcb.inbox_entries = inbox_entries;
 	
 	async_answer_0(rid, rc);
@@ -282,12 +311,8 @@
 static void ldr_run(ipc_callid_t rid, ipc_call_t *request)
 {
-	const char *cp;
-	
 	DPRINTF("Set task name\n");
 
 	/* Set the task name. */
-	cp = str_rchr(pathname, '/');
-	cp = (cp == NULL) ? pathname : (cp + 1);
-	task_set_name(cp);
+	task_set_name(progname);
 	
 	/* Run program */
@@ -336,12 +361,12 @@
 			ldr_set_cwd(callid, &call);
 			continue;
-		case LOADER_SET_PATHNAME:
-			ldr_set_pathname(callid, &call);
+		case LOADER_SET_PROGRAM:
+			ldr_set_program(callid, &call);
 			continue;
 		case LOADER_SET_ARGS:
 			ldr_set_args(callid, &call);
 			continue;
-		case LOADER_SET_FILES:
-			ldr_set_files(callid, &call);
+		case LOADER_ADD_INBOX:
+			ldr_add_inbox(callid, &call);
 			continue;
 		case LOADER_LOAD:
Index: uspace/srv/logger/ctl.c
===================================================================
--- uspace/srv/logger/ctl.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/logger/ctl.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -41,4 +41,5 @@
 #include <io/logctl.h>
 #include <ipc/logger.h>
+#include <vfs/vfs.h>
 #include "logger.h"
 
@@ -86,4 +87,10 @@
 			break;
 		}
+		case LOGGER_CONTROL_SET_ROOT: {
+			int fd = vfs_receive_handle(true);
+			vfs_root_set(fd);
+			async_answer_0(callid, fd >= 0 ? EOK : fd);
+			break;
+		}
 		default:
 			async_answer_0(callid, EINVAL);
Index: uspace/srv/vfs/Makefile
===================================================================
--- uspace/srv/vfs/Makefile	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/Makefile	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -39,4 +39,5 @@
 	vfs_lookup.c \
 	vfs_register.c \
+	vfs_ipc.c \
 	vfs_pager.c
 
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -76,96 +76,8 @@
 }
 
-static void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	bool cont = true;
-	
-	/*
-	 * The connection was opened via the IPC_CONNECT_ME_TO call.
-	 * This call needs to be answered.
-	 */
-	async_answer_0(iid, EOK);
-	
-	while (cont) {
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		
-		if (!IPC_GET_IMETHOD(call))
-			break;
-		
-		switch (IPC_GET_IMETHOD(call)) {
-		case VFS_IN_REGISTER:
-			vfs_register(callid, &call);
-			cont = false;
-			break;
-		case VFS_IN_MOUNT:
-			vfs_mount_srv(callid, &call);
-			break;
-		case VFS_IN_UNMOUNT:
-			vfs_unmount_srv(callid, &call);
-			break;
-		case VFS_IN_OPEN:
-			vfs_open(callid, &call);
-			break;
-		case VFS_IN_CLOSE:
-			vfs_close(callid, &call);
-			break;
-		case VFS_IN_READ:
-			vfs_read(callid, &call);
-			break;
-		case VFS_IN_WRITE:
-			vfs_write(callid, &call);
-			break;
-		case VFS_IN_SEEK:
-			vfs_seek(callid, &call);
-			break;
-		case VFS_IN_TRUNCATE:
-			vfs_truncate(callid, &call);
-			break;
-		case VFS_IN_FSTAT:
-			vfs_fstat(callid, &call);
-			break;
-		case VFS_IN_STAT:
-			vfs_stat(callid, &call);
-			break;
-		case VFS_IN_MKDIR:
-			vfs_mkdir(callid, &call);
-			break;
-		case VFS_IN_UNLINK:
-			vfs_unlink(callid, &call);
-			break;
-		case VFS_IN_RENAME:
-			vfs_rename(callid, &call);
-			break;
-		case VFS_IN_SYNC:
-			vfs_sync(callid, &call);
-			break;
-		case VFS_IN_DUP:
-			vfs_dup(callid, &call);
-			break;
-		case VFS_IN_WAIT_HANDLE:
-			vfs_wait_handle(callid, &call);
-			break;
-		case VFS_IN_MTAB_GET:
-			vfs_get_mtab(callid, &call);
-			break;
-		case VFS_IN_STATFS:
-			vfs_statfs(callid, &call);
-			break;
-		default:
-			async_answer_0(callid, ENOTSUP);
-			break;
-		}
-	}
-	
-	/*
-	 * Open files for this client will be cleaned up when its last
-	 * connection fibril terminates.
-	 */
-}
-
 static void notification_handler(ipc_callid_t callid, ipc_call_t *call, void *arg)
 {
 	if (IPC_GET_ARG1(*call) == VFS_PASS_HANDLE)
-		vfs_pass_handle(
+		vfs_op_pass_handle(
 		    (task_id_t) MERGE_LOUP32(IPC_GET_ARG4(*call),
 		    IPC_GET_ARG5(*call)), call->in_task_id,
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs.h	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -94,5 +94,4 @@
 	vfs_node_type_t type;
 	aoff64_t size;
-	unsigned int lnkcnt;
 } vfs_lookup_res_t;
 
@@ -101,5 +100,5 @@
  * which may be associated with it.
  */
-typedef struct {
+typedef struct _vfs_node {
 	VFS_TRIPLET;		/**< Identity of the node. */
 
@@ -110,7 +109,4 @@
 	unsigned refcnt;
 	
-	/** Number of names this node has in the file system namespace. */
-	unsigned lnkcnt;
-
 	ht_link_t nh_link;		/**< Node hash-table link. */
 
@@ -123,4 +119,6 @@
 	 */
 	fibril_rwlock_t contents_rwlock;
+	
+	struct _vfs_node *mount;
 } vfs_node_t;
 
@@ -131,5 +129,5 @@
 typedef struct {
 	/** Serializes access to this open file. */
-	fibril_mutex_t lock;
+	fibril_mutex_t _lock;
 
 	vfs_node_t *node;
@@ -138,9 +136,10 @@
 	unsigned refcnt;
 
+	int permissions;
+	bool open_read;
+	bool open_write;
+
 	/** Append on write. */
 	bool append;
-
-	/** Current absolute position in the file. */
-	aoff64_t pos;
 } vfs_file_t;
 
@@ -173,29 +172,29 @@
 extern void vfs_exchange_release(async_exch_t *);
 
-extern fs_handle_t fs_name_to_handle(unsigned int instance, char *, bool);
+extern fs_handle_t fs_name_to_handle(unsigned int instance, const char *, bool);
 extern vfs_info_t *fs_handle_to_info(fs_handle_t);
 
-extern int vfs_lookup_internal(char *, int, vfs_lookup_res_t *,
-    vfs_pair_t *, ...);
+extern int vfs_lookup_internal(vfs_node_t *, char *, int, vfs_lookup_res_t *);
+extern int vfs_link_internal(vfs_node_t *, char *, vfs_triplet_t *);
 
 extern bool vfs_nodes_init(void);
 extern vfs_node_t *vfs_node_get(vfs_lookup_res_t *);
+extern vfs_node_t *vfs_node_peek(vfs_lookup_res_t *result);
 extern void vfs_node_put(vfs_node_t *);
 extern void vfs_node_forget(vfs_node_t *);
 extern unsigned vfs_nodes_refcount_sum_get(fs_handle_t, service_id_t);
 
-
-#define MAX_OPEN_FILES	128
+extern bool vfs_node_has_children(vfs_node_t *node);
 
 extern void *vfs_client_data_create(void);
 extern void vfs_client_data_destroy(void *);
 
-extern void vfs_pass_handle(task_id_t, task_id_t, int);
-extern int vfs_wait_handle_internal(void);
+extern void vfs_op_pass_handle(task_id_t, task_id_t, int);
+extern int vfs_wait_handle_internal(bool);
 
 extern vfs_file_t *vfs_file_get(int);
 extern void vfs_file_put(vfs_file_t *);
 extern int vfs_fd_assign(vfs_file_t *, int);
-extern int vfs_fd_alloc(bool desc);
+extern int vfs_fd_alloc(vfs_file_t **file, bool desc);
 extern int vfs_fd_free(int);
 
@@ -204,23 +203,22 @@
 extern int vfs_open_node_remote(vfs_node_t *);
 
+extern int vfs_op_clone(int oldfd, int newfd, bool desc);
+extern int vfs_op_mount(int mpfd, unsigned servid, unsigned flags, unsigned instance, const char *opts, const char *fsname, int *outfd);
+extern int vfs_op_mtab_get(void);
+extern int vfs_op_open(int fd, int flags);
+extern int vfs_op_put(int fd);
+extern int vfs_op_read(int fd, aoff64_t, size_t *out_bytes);
+extern int vfs_op_rename(int basefd, char *old, char *new);
+extern int vfs_op_resize(int fd, int64_t size);
+extern int vfs_op_stat(int fd);
+extern int vfs_op_statfs(int fd);
+extern int vfs_op_sync(int fd);
+extern int vfs_op_unlink(int parentfd, int expectfd, char *path);
+extern int vfs_op_unmount(int mpfd);
+extern int vfs_op_wait_handle(bool high_fd);
+extern int vfs_op_walk(int parentfd, int flags, char *path, int *out_fd);
+extern int vfs_op_write(int fd, aoff64_t, size_t *out_bytes);
+
 extern void vfs_register(ipc_callid_t, ipc_call_t *);
-extern void vfs_mount_srv(ipc_callid_t, ipc_call_t *);
-extern void vfs_unmount_srv(ipc_callid_t, ipc_call_t *);
-extern void vfs_open(ipc_callid_t, ipc_call_t *);
-extern void vfs_sync(ipc_callid_t, ipc_call_t *);
-extern void vfs_dup(ipc_callid_t, ipc_call_t *);
-extern void vfs_close(ipc_callid_t, ipc_call_t *);
-extern void vfs_read(ipc_callid_t, ipc_call_t *);
-extern void vfs_write(ipc_callid_t, ipc_call_t *);
-extern void vfs_seek(ipc_callid_t, ipc_call_t *);
-extern void vfs_truncate(ipc_callid_t, ipc_call_t *);
-extern void vfs_fstat(ipc_callid_t, ipc_call_t *);
-extern void vfs_stat(ipc_callid_t, ipc_call_t *);
-extern void vfs_mkdir(ipc_callid_t, ipc_call_t *);
-extern void vfs_unlink(ipc_callid_t, ipc_call_t *);
-extern void vfs_rename(ipc_callid_t, ipc_call_t *);
-extern void vfs_wait_handle(ipc_callid_t, ipc_call_t *);
-extern void vfs_get_mtab(ipc_callid_t, ipc_call_t *);
-extern void vfs_statfs(ipc_callid_t, ipc_call_t *);
 
 extern void vfs_page_in(ipc_callid_t, ipc_call_t *);
@@ -231,5 +229,7 @@
 } rdwr_io_chunk_t;
 
-extern int vfs_rdwr_internal(int, bool, rdwr_io_chunk_t *);
+extern int vfs_rdwr_internal(int, aoff64_t, bool, rdwr_io_chunk_t *);
+
+extern void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg);
 
 #endif
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_file.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,4 +45,5 @@
 #include <adt/list.h>
 #include <task.h>
+#include <vfs/vfs.h>
 #include "vfs.h"
 
@@ -59,5 +60,6 @@
 typedef struct {
 	link_t link;
-	int handle;
+	vfs_node_t *node;
+	int permissions;
 } vfs_boxed_handle_t;
 
@@ -177,6 +179,11 @@
 		 * endpoint FS and drop our reference to the underlying VFS node.
 		 */
-		rc = vfs_file_close_remote(file);
-		vfs_node_delref(file->node);
+		
+		if (file->node != NULL) {
+			if (file->open_read || file->open_write) {
+				rc = vfs_file_close_remote(file);
+			}
+			vfs_node_delref(file->node);
+ 		}
 		free(file);
 	}
@@ -185,5 +192,5 @@
 }
 
-static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, bool desc)
+static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, vfs_file_t **file, bool desc)
 {
 	if (!vfs_files_init(vfs_data))
@@ -205,7 +212,14 @@
 			}
 			
+			
 			memset(vfs_data->files[i], 0, sizeof(vfs_file_t));
-			fibril_mutex_initialize(&vfs_data->files[i]->lock);
+			
+			fibril_mutex_initialize(&vfs_data->files[i]->_lock);
+			fibril_mutex_lock(&vfs_data->files[i]->_lock);
 			vfs_file_addref(vfs_data, vfs_data->files[i]);
+			
+			*file = vfs_data->files[i];
+			vfs_file_addref(vfs_data, *file);
+			
 			fibril_mutex_unlock(&vfs_data->lock);
 			return (int) i;
@@ -231,4 +245,5 @@
 /** Allocate a file descriptor.
  *
+ * @param file Is set to point to the newly created file structure. Must be put afterwards.
  * @param desc If true, look for an available file descriptor
  *             in a descending order.
@@ -237,7 +252,7 @@
  *         code.
  */
-int vfs_fd_alloc(bool desc)
-{
-	return _vfs_fd_alloc(VFS_DATA, desc);
+int vfs_fd_alloc(vfs_file_t **file, bool desc)
+{
+	return _vfs_fd_alloc(VFS_DATA, file, desc);
 }
 
@@ -289,7 +304,11 @@
 
 	fibril_mutex_lock(&VFS_DATA->lock);	
-	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || (FILES[fd] != NULL)) {
+	if ((fd < 0) || (fd >= MAX_OPEN_FILES)) {
 		fibril_mutex_unlock(&VFS_DATA->lock);
-		return EINVAL;
+		return EBADF;
+	}
+	if (FILES[fd] != NULL) {
+		fibril_mutex_unlock(&VFS_DATA->lock);
+		return EEXIST;
 	}
 	
@@ -299,4 +318,13 @@
 	
 	return EOK;
+}
+
+static void _vfs_file_put(vfs_client_data_t *vfs_data, vfs_file_t *file)
+{
+	fibril_mutex_unlock(&file->_lock);
+	
+	fibril_mutex_lock(&vfs_data->lock);
+	vfs_file_delref(vfs_data, file);
+	fibril_mutex_unlock(&vfs_data->lock);
 }
 
@@ -312,4 +340,12 @@
 			vfs_file_addref(vfs_data, file);
 			fibril_mutex_unlock(&vfs_data->lock);
+			
+			fibril_mutex_lock(&file->_lock);
+			if (file->node == NULL) {
+				_vfs_file_put(vfs_data, file);
+				return NULL;
+			}
+			assert(file != NULL);
+			assert(file->node != NULL);
 			return file;
 		}
@@ -331,11 +367,4 @@
 }
 
-static void _vfs_file_put(vfs_client_data_t *vfs_data, vfs_file_t *file)
-{
-	fibril_mutex_lock(&vfs_data->lock);
-	vfs_file_delref(vfs_data, file);
-	fibril_mutex_unlock(&vfs_data->lock);
-}
-
 /** Stop using a file structure.
  *
@@ -347,12 +376,10 @@
 }
 
-void vfs_pass_handle(task_id_t donor_id, task_id_t acceptor_id, int donor_fd)
+void vfs_op_pass_handle(task_id_t donor_id, task_id_t acceptor_id, int donor_fd)
 {
 	vfs_client_data_t *donor_data = NULL;
 	vfs_client_data_t *acceptor_data = NULL;
 	vfs_file_t *donor_file = NULL;
-	vfs_file_t *acceptor_file = NULL;
 	vfs_boxed_handle_t *bh;
-	int acceptor_fd;
 
 	acceptor_data = async_get_client_data_by_id(acceptor_id);
@@ -364,5 +391,5 @@
 
 	link_initialize(&bh->link);
-	bh->handle = -1;
+	bh->node = NULL;
 
 	donor_data = async_get_client_data_by_id(donor_id);
@@ -373,10 +400,4 @@
 	if (!donor_file)
 		goto out;
-
-	acceptor_fd = _vfs_fd_alloc(acceptor_data, false);
-	if (acceptor_fd < 0)
-		goto out;
-
-	bh->handle = acceptor_fd;
 
 	/*
@@ -384,15 +405,6 @@
 	 */
 	vfs_node_addref(donor_file->node);
-	(void) vfs_open_node_remote(donor_file->node);
-
-	acceptor_file = _vfs_file_get(acceptor_data, acceptor_fd);
-	assert(acceptor_file);
-
-	/*
-	 * Inherit attributes from the donor.
-	 */
-	acceptor_file->node = donor_file->node;
-	acceptor_file->append = donor_file->append;
-	acceptor_file->pos = donor_file->pos;
+	bh->node = donor_file->node;
+	bh->permissions = donor_file->permissions;
 
 out:
@@ -408,13 +420,9 @@
 	if (donor_file)
 		_vfs_file_put(donor_data, donor_file);
-	if (acceptor_file)
-		_vfs_file_put(acceptor_data, acceptor_file);
-
-}
-
-int vfs_wait_handle_internal(void)
+}
+
+int vfs_wait_handle_internal(bool high_fd)
 {
 	vfs_client_data_t *vfs_data = VFS_DATA;	
-	int fd;
 	
 	fibril_mutex_lock(&vfs_data->lock);
@@ -426,7 +434,17 @@
 
 	vfs_boxed_handle_t *bh = list_get_instance(lnk, vfs_boxed_handle_t, link);
-	fd = bh->handle;
+
+	vfs_file_t *file;
+	int fd = _vfs_fd_alloc(vfs_data, &file, high_fd);
+	if (fd < 0) {
+		vfs_node_delref(bh->node);
+		free(bh);
+		return fd;
+	}
+	
+	file->node = bh->node;
+	file->permissions = bh->permissions;
+	vfs_file_put(file);
 	free(bh);
-
 	return fd;
 }
